module CantorWith where

  data Empty : Set where

  data One : Set where
    one : One

  data coprod (A : Set1) (B : Set1) : Set1 where
    inl : ∀ (a : A) -> coprod A B
    inr : ∀ (b : B) -> coprod A B

  postulate exmid : ∀ (A : Set1) -> coprod A (A -> Empty)

  data Eq1 {A : Set1} (x : A) : A -> Set1 where
    refl : Eq1 x x

  data I : (Set -> Set) -> Set where

  data invI (a : Set) : Set1 where
    inv : forall x -> (Eq1 (I x) a) -> invI a

  cantor : Set -> Set
  cantor a with exmid (invI a)
  cantor .(I x) | inl (inv x refl) = x (I x) -> Empty
  cantor a | inr b = One

  CANTOR : Set
  CANTOR = I cantor

  no' : cantor CANTOR -> cantor CANTOR -> Empty
  no' p with exmid (invI CANTOR)
  no' p | inl (inv .cantor refl) = λ q → {!q p!}
{-
p : cantor (I cantor) | exmid (invI (I cantor)) → Empty
q : cantor (I cantor) | exmid (invI (I cantor)) → Empty
————————————————————————————————————————————————————————————
Goal: Empty
-}
  no' p | inr b = λ q → b (inv cantor refl)

  no : cantor CANTOR -> Empty
  no p = no' p p

  yes : cantor CANTOR
  yes with exmid (invI CANTOR)
  yes | inl (inv .cantor refl) = no
  yes | inr b = one

  Ω : Empty
  Ω = no yes
